// Librairie de listes chaînées de chaines de caractères de taille statique

#include "liste.h"

//Affichage de la liste en ligne
void afficherListe(Liste l) {
  if (l==NULL)
    printf("\n");
  else {
    printf("%s, ", l->val);//chaine!
    afficherListe(l->suiv);
  }
}

void ajoutTete(Liste *pl, char mot[MAXSIZE]) {
  Ptcellule p = (Ptcellule) malloc(sizeof(Cellule));
  strncpy(p->val,mot,MAXSIZE);
  p->suiv = *pl;
  *pl=p;
}

void suppTete(Liste *pl){
  //  printf("%p est le pointeur !!!\n",pl);
  if (pl != NULL) {
    Ptcellule p=*pl;
    if (p != NULL) *pl= (*pl)->suiv;
    free(p);
  }
}

//ajout trie from BC
void ajoutAlphab(Liste *pl, char mot[MAXSIZE]) {
  if ( (*pl==NULL) || (strcmp(mot, (*pl)->val) < 0) ) { // empty list or mot < head => new head
    ajoutTete(pl,mot);
  } else {
    if (strcmp(mot, (*pl)->val) > 0) { // mot > head => add in next's
      ajoutAlphab(&(*pl)->suiv,mot);
    } // else mot already in list
  }
}

//BC !
//chargement à partir d'un fichier de mots. -> liste ordonnee
void chargeFichier(FILE *fp, Liste *pl) {
  char mot[MAXSIZE];
  fscanf(fp, "%s", mot);
  while (!feof(fp)) {
    ajoutAlphab(pl,mot);
    fscanf(fp, "%s", mot);
  }
}

//appartient dans liste pas triée.
bool appartient(Liste l,char mot[MAXSIZE]) {
  if (l==NULL) 
    return(false);
  else 
    if (strncmp(mot,l->val,MAXSIZE)==0)
      return(true);
    else
      return(appartient(l->suiv,mot));
}

int taille(Liste l) {
  if (l==NULL) 
    return 0;
  else 
    return 1 + taille(l->suiv);
}

//Destruction de Liste.
void detruireListe(Liste* l) {
  if (l==NULL) return;
  if (*l==NULL) return;
  else {
    Liste* pt_reste = &((*l)-> suiv);
    free(*l);
    detruireListe(pt_reste);
  }
}
